
/*
Copyright 2007-2008 Kim A. Brandt <kimabrandt@gmx.de>

This file is part of prefswitch.

Prefswitch is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Prefswitch is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with prefswitch; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

prefswitch.Observer = function(control, type, prefRoot, preference, element)
{
	this.control = control ? control : null;
	this.type = type ? type : "";
	this.prefRoot = prefRoot ? prefRoot : "";
//	this.preference = preference ? preference : "";
	this.element = element ? element : null;
	this.observable = null;
	this.enabled = true;

	this.register = function()
	{
		this.observable = this.control.prefService.getBranch(this.prefRoot);
		this.observable.QueryInterface(Components.interfaces.nsIPrefBranch2);
		this.observable.addObserver("", this, false);
	}

	this.unregister = function()
	{
		if (this.observable) this.observable.removeObserver("", this);
	}

	this.observe = function(aSubject, aTopic, aData)
	{
		if (this.enabled /*&& aData == this.preference*/) this.control.update(this.type, this.element);
	}

	this.enable = function()
	{
		this.enabled = true;
	}

	this.disable = function()
	{
		this.enabled = false;
	}
}
