
/*
Copyright 2007-2008 Kim A. Brandt <kimabrandt@gmx.de>

This file is part of prefswitch.

Prefswitch is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Prefswitch is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with prefswitch; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

prefswitch.Profile = function(id, name)
{
	this.id = "";
	this.name = "";
	this.features = {}

	this.setID = function(value)
	{
		if(value && value != "") this.id = "" + value;
		else this.id = this.generateID();
	}

	this.setName = function(value)
	{
		if (value) this.name = "" + value;
	}

	this.setFeature = function(key, value, show, disabled)
	{
		if(!key || !value || key == "") return;
		var tmp = {}
		tmp.value = "" + value;
		tmp.show = "" + show == "true";
		tmp.disabled = "" + disabled == "true";
		this.features["" + key] = tmp;
	}

	this.setFeatures = function(value)
	{
		this.features = value;
	}

	this.getID = function()
	{
		return this.id;
	}

	this.getName = function()
	{
		return this.name;
	}

	this.getFeature = function(key)
	{
		if(!key || key == "") return null;
		if(!this.features.hasOwnProperty("" + key)) return null;
		return this.features["" + key];
	}

	this.getFeatures = function()
	{
		return this.features;
	}

	this.generateID = function()
	{
		var date = new Date();
		return "" + date.getTime();
	}

	this.setID(id);
	this.setName(name);
}
